clear


quat2rot = @(q) [ q(1)^2+q(2)^2-q(3)^2-q(4)^2, 2*q(2)*q(3)-2*q(1)*q(4), 2*q(1)*q(3)+2*q(2)*q(4);...
                  2*q(1)*q(4)+2*q(2)*q(3), q(1)^2-q(2)^2+q(3)^2-q(4)^2, 2*q(3)*q(4)-2*q(1)*q(2);...
                  2*q(2)*q(4)-2*q(1)*q(3), 2*q(1)*q(2)+2*q(3)*q(4), q(1)^2-q(2)^2-q(3)^2+q(4)^2];


T = sym('T',[2 2 2]);
eq_internal = T(1)^3*T(8) - T(1)^2*T(2)*T(7) - T(1)^2*T(3)*T(6) - T(1)^2*T(4)*T(5) + T(1)*T(2)^2*T(8) + 2*T(1)*T(2)*T(3)*T(5) - 2*T(1)*T(2)*T(4)*T(6) + T(1)*T(3)^2*T(8) - 2*T(1)*T(3)*T(4)*T(7) - T(1)*T(4)^2*T(8) + T(1)*T(5)^2*T(8) - 2*T(1)*T(5)*T(6)*T(7) - T(1)*T(6)^2*T(8) - T(1)*T(7)^2*T(8) - T(1)*T(8)^3 - T(2)^3*T(7) + T(2)^2*T(3)*T(6) + T(2)^2*T(4)*T(5) + T(2)*T(3)^2*T(7) + 2*T(2)*T(3)*T(4)*T(8) - T(2)*T(4)^2*T(7) + T(2)*T(5)^2*T(7) + 2*T(2)*T(5)*T(6)*T(8) - T(2)*T(6)^2*T(7) + T(2)*T(7)^3 + T(2)*T(7)*T(8)^2 - T(3)^3*T(6) + T(3)^2*T(4)*T(5) - T(3)*T(4)^2*T(6) + T(3)*T(5)^2*T(6) + 2*T(3)*T(5)*T(7)*T(8) + T(3)*T(6)^3 - T(3)*T(6)*T(7)^2 + T(3)*T(6)*T(8)^2 + T(4)^3*T(5) - T(4)*T(5)^3 - T(4)*T(5)*T(6)^2 - T(4)*T(5)*T(7)^2 + T(4)*T(5)*T(8)^2 - 2*T(4)*T(6)*T(7)*T(8);

calibrated = 1

if calibrated
    % Calibrated cameras
    q2 = sym('q2',[4 1]);
    q3 = sym('q3',[4 1]);
    R1 = [eye(2) [0;0]];
    R2 = quat2rot(q2);
    R3 = quat2rot(q3);    
else 
    % Projective cameras
    R1 = [eye(2) [0;0]];
    R2 = sym('A',[2 3]);
    R3 = sym('B',[2 3]);
end
    

% Compute tensor from cameras
T_R = sym(zeros(2,2,2));
for i = 1:2
    for j = 1:2
        for k = 1:2
            indP1 = setdiff(1:2,i);
            indP2 = setdiff(1:2,j);
            indP3 = setdiff(1:2,k);
            T_R(i,j,k) = (-1)^(i+j+k)*det([R1(indP1,:);R2(indP2,:);R3(indP3,:)]);
        end
    end
end


% Evaluate constraint on tensor
simplify(subs(eq_internal, T(:), T_R(:)))






